//
//  MathTools.java
//  Treehousestudio
//
//  Created by Maxwell Planck on Wed Jan 22 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

import java.awt.*;

/**
 * This method provides calculation tools for the drawing classes
 */

public class MathTools {
    
    public static void triangulate(Point[] P, Triangle[] tr) {
        // P contains all n polygon vertices in CCW order.
        // The resulting triangles will be stored in array tr.
        // This array tr must have length n - 2.
        int n = P.length, j = n - 1, iA=0, iB, iC;
        int[] next = new int[n];
        for (int i=0; i<n; i++)
        {  next[j] = i;
            j = i;
        }
        for (int k=0; k<n-2; k++)
        {  // Find a suitable triangle, consisting of two edges
           // and an internal diagonal:
            Point A, B, C;
            boolean triaFound = false;
            int count = 0;
            while (!triaFound && ++count < n)
            {  iB = next[iA]; iC = next[iB];
            A = P[iA]; B = P[iB]; C = P[iC];
            if (area2(A, B, C) >= 0)
            {  // Edges AB and BC; diagonal AC.
               // Test to see if no other polygon vertex
               // lies within triangle ABC:
                j = next[iC];
                while (j != iA && !insideTriangle(A, B, C, P[j]))
                    j = next[j];
                if (j == iA)
                {  // Triangle ABC contains no other vertex:
                    tr[k] = new Triangle(A, B, C);
                    next[iA] = iC;
                    triaFound = true;
                }
            }
            iA = next[iA];
            }
            if (count == n)
            {  //Not a simple polygon
               //or vertex sequence not counter-clockwise
                throw new RuntimeException("Catch this");
            }
        }
    }

    public static float area2(Point A, Point B, Point C) {
        return (A.x - C.x) * (B.y - C.y) - (A.y - C.y) * (B.x - C.x);
    }

    public static boolean insideTriangle(Point A, Point B, Point C, Point P){
        // ABC is assumed to be counter-clockwisereturn
        return area2(A, B, P) >= 0 &&
        area2(B, C, P) >= 0 &&
        area2(C, A, P) >= 0;
    }
    
}

class Triangle
{  Point A, B, C;
    Triangle(Point A, Point B, Point C)
    {  this.A = A; this.B = B; this.C = C;
    }
}

