//
//  PaintCanvas.java
//  Treehousestudio
//
//  Created by john maeda on Thu Aug 15 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//


import java.awt.*;
import java.applet.*;
import java.util.*;

import cgio;
import paintbrush;
import THSPanel;

/**
* This class performs all of the drawing performed in the Applet.  It also handles saving itself.
 */
public class PaintCanvas extends THSCanvas
{

    final static int TOOLSELECTED = 1,
    FGCOLOR = 2,
    BGCOLOR = 3,
    DCLICK = 4;

    THSGeneralTool selectedTool;
    
    int mode;
    int lastmx, lastmy;
    int startmx, startmy;
    int firstpolymx, firstpolymy;
    Image imstk;
    Graphics gstk;

    boolean pushedp = false;
    boolean isDrawingPoly = false;
    boolean isDrawingFilledPoly = false;

    Poly polygon;
    TypeTool tfield;
    Shapes shape;
    
    /**
     * This method is called from anywhere in the applet 
     **/
    public void message(String fromWho, Object odat)
    {
        if (fromWho.equals("Icon Panel")) {
                // before change mode
                /*if ((selectedTool != null) && (selectedTool.getString() == "Type")) {
                    selectedTool.textFreeze(gi);
                }*/
                selectedTool = (THSGeneralTool) odat;
                return;
        }
        
        if (fromWho.equals("FGColor Change")) {
            fgcol = (Color) odat;
            return;
        }
        if (fromWho.equals("BGColor Change")) {
            bgcol = (Color) odat;
            return;
        }
        if (fromWho.equals("Doubleclick")) { // double click
                selectedTool = (THSGeneralTool) odat;
                System.out.println("doubleclick");
                if (selectedTool.getString() == "Eraser") {
                        clearbuffer();
                }
            return;
        }
        System.err.println("An improper message was sent to the Paint Canvas");
    }

    /**
     * If the tool used does not draw in realtime, then call push() to save the state of the graphics before the tool
     * is begun (mouse pressed down).  This saves the graphics that are being drawn over so that, for example,
     * drawing a line doesn't result in messiness (the line is drawn every time the mouse is moved).
     */
    public void mouseDown(Event ev, int mx, int my) {

        // reset the mouse coordinates for this THSPanel
        mx-=cx; my-=cy;

        lastmx = mx; lastmy = my;
        startmx = mx; startmy = my;

        cacheundo();
        selectedTool.mouseDown(mx, my, this);
        /*
        switch(mode) {
            case THSIconPanel.TYPE:
                ();
                cacheundo();
                tfield.setCursor(gi, mx, my);
                break;
            case THSIconPanel.SPRAY:
                resetTools();
                cacheundo();
                gi.setColor(fgcol);
                Simple.dospray(gi,mx,my);
                break;
            case THSIconPanel.ERASER:
                resetTools();
                cacheundo();
                gi.setColor(fgcol);
                gi.setColor(Color.white);
                Simple.line(gi,curbsh,lastmx,lastmy,mx,my);
                break;
            case THSIconPanel.PENCIL:
            case THSIconPanel.BRUSH:
                resetTools();
                cacheundo();
                gi.setColor(fgcol);
                Simple.line(gi,curbsh,lastmx,lastmy,mx,my);
                break;
            case THSIconPanel.LINE:
                resetTools();
                cacheundo();
                gi.setColor(fgcol);
                push();
                Simple.line(gi,curbsh,startmx,startmy,mx,my);
                break;
            case THSIconPanel.RECT:
                resetTools();
                cacheundo();
                gi.setColor(fgcol);
                push();
                shape = new Shapes(startmx, startmy);
                break;
            case THSIconPanel.RECTFILL:
                resetTools();
                cacheundo();
                gi.setColor(fgcol);
                cacheundo();
                push();
                shape = new Shapes(startmx, startmy);
                break;
            case THSIconPanel.OVAL:
                resetTools();
                cacheundo();
                gi.setColor(fgcol);
                push();
                shape = new Shapes(startmx, startmy);
                break;
            case THSIconPanel.OVALFILL:
                resetTools();
                cacheundo();
                gi.setColor(fgcol);
                push();
                shape = new Shapes(startmx, startmy);
                break;
            case THSIconPanel.BUCKET:
                resetTools();
                cacheundo();
                gi.setColor(fgcol);
                Simple.floodfill(im,app,cw,ch,mx,my);
            case THSIconPanel.FBLOB:
            case THSIconPanel.BLOB:
                resetTools();
                cacheundo();
                gi.setColor(fgcol);
                Simple.line(gi,curbsh,lastmx,lastmy,mx,my);
                break;
            case THSIconPanel.FPOLY:
                isDrawingFilledPoly = true;
            case THSIconPanel.POLY:
                gi.setColor(fgcol);
                if (!isDrawingPoly) { // First time
                    isDrawingPoly = true;
                    cacheundo();
                    push();
                    polygon = new Poly(gi, isDrawingFilledPoly, mx, my);
                }
                break;
            default:
                break;
        }*/
    }

    /**
     * For this method, if gi.drawImage(imstk,0,0,app) is called before anything is drawn to the graphic, the state
     * of the canvas before the tool was begun (mouse was clicked) is drawn before the resulting drag action is
     * drawn on top of it.  For example, when drawing a line, if this line is not used, the line would draw
     * to the actual canvas every time the mouse is dragged, resulting in an undesirable messiness.
     */
    public void mouseDrag(Event ev, int mx, int my) {
        mx-=cx; my-=cy;

        selectedTool.mouseDrag(mx, my, this);
        /*
        switch(mode) {
            case THSIconPanel.SPRAY:
                gi.setColor(fgcol);
                Simple.dospray(gi,mx,my);
                break;
            case THSIconPanel.ERASER:
                gi.setColor(Color.white);
                Simple.line(gi,curbsh,lastmx,lastmy,mx,my);
                break;
            case THSIconPanel.PENCIL: //Pencil behaves just like a Brush
            case THSIconPanel.BRUSH:
                gi.setColor(fgcol);
                Simple.line(gi,curbsh,lastmx,lastmy,mx,my);
                break;
            case THSIconPanel.LINE:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                Simple.line(gi,curbsh,startmx,startmy,mx,my);
                break;
            case THSIconPanel.RECT:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                shape.rectadjusted(gi,curbsh,mx,my);
                break;
            case THSIconPanel.RECTFILL:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                shape.rectfilladjusted(gi,curbsh,mx,my);
                break;
            case THSIconPanel.OVAL:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                shape.ovaladjusted(gi,curbsh,mx,my);
                break;
            case THSIconPanel.OVALFILL:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                shape.ovalfilladjusted(gi,curbsh,mx,my);
                break;
            case THSIconPanel.FBLOB:
            case THSIconPanel.BLOB:
                gi.setColor(fgcol);
                Simple.line(gi,curbsh,lastmx,lastmy,mx,my);
                break;
            case THSIconPanel.FPOLY:
            case THSIconPanel.POLY:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                polygon.drawPoly(gi, curbsh, mx, my);
                break;
            default:
                break;
        }*/
    }

    /**
     * Does anything happen when the mouse is moved?
     */
    public void mouseMove(Event ev, int mx, int my) {
        mx-=cx;my-=cy;
        selectedTool.mouseMove(mx, my, this);
        
        /*switch(mode) {
            case THSIconPanel.FPOLY:
            case THSIconPanel.POLY:
                if (isDrawingPoly) {
                    gi.setColor(fgcol);
                    gi.drawImage(imstk, 0, 0, app);
                    polygon.drawPoly(gi, curbsh, mx, my);
                }
                break;
            case THSIconPanel.TYPE:
                tfield.textfreeze(gi);
            default:
                return;
        }*/
    }

    /**
     * Does anything happen when the mouse is released?
     */
    public void mouseUp(Event ev, int mx, int my) {
        mx-=cx; my-=cy;
        selectedTool.mouseUp(mx, my, this);
        
        /*switch(mode) {
            case THSIconPanel.SPRAY:
                gi.setColor(fgcol);
                Simple.dospray(gi,mx,my);
                break;
            case THSIconPanel.ERASER:
                gi.setColor(Color.white);
                Simple.line(gi,curbsh,lastmx,lastmy,mx,my);
                break;
            case THSIconPanel.PENCIL:
            case THSIconPanel.BRUSH:
                gi.setColor(fgcol);
                Simple.line(gi,curbsh,lastmx,lastmy,mx,my);
                break;
            case THSIconPanel.LINE:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                Simple.line(gi,curbsh,startmx,startmy,mx,my);
                pop();
                break;
            case THSIconPanel.RECT:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                shape.rectadjusted(gi, curbsh, mx, my);
                pop();
                break;
            case THSIconPanel.RECTFILL:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                shape.rectfilladjusted(gi,curbsh,mx,my);
                pop();
                break;
            case THSIconPanel.OVAL:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                shape.ovaladjusted(gi,curbsh,mx,my);
                pop();
                break;
            case THSIconPanel.OVALFILL:
                gi.setColor(fgcol);
                gi.drawImage(imstk,0,0,app);
                shape.ovalfilladjusted(gi,curbsh,mx,my);
                pop();
                break;
            case THSIconPanel.BLOB:
                gi.setColor(fgcol);
                Simple.line(gi,curbsh,mx,my,startmx,startmy);
                break;
            case THSIconPanel.FBLOB:
                gi.setColor(fgcol);
                Simple.line(gi,curbsh,mx,my,startmx,startmy);
                break;
            case THSIconPanel.FPOLY:
            case THSIconPanel.POLY:
                gi.setColor(fgcol);
                if (checkDoubleClick(mx, my)) {
                    isDrawingFilledPoly = false;
                    isDrawingPoly = false;
                    polygon.finishPoly(gi, mx, my);
                    polygon.drawPoly(gi, curbsh, mx, my);
                    pop();
                    break;
                }
                polygon.addPolyPoint(mx, my);
                polygon.drawPoly(gi, curbsh, mx, my);
                break;
            default:
                break;
        }*/
    }

    public boolean keyDown(Event ev, int k)
    {
        return selectedTool.keyDown(ev, k, this);
    }

    public boolean keyPressed(Event ev, int k)
    {
        return selectedTool.keyPressed(ev, k, this);
    }

    public boolean keyUp(Event ev, int k)
    {
        return selectedTool.keyUp(ev, k, this);
    }
    
    Image im;
    Graphics gi;

    Image imundo;
    Graphics giu;

    Image imtmp;
    Graphics git;

    Applet app;
    static paintbrush curbsh;
    roundbrush rbsh;
    squarebrush sbsh;
    imbrush ibsh[] = new imbrush[16];

    int dimbrush = 10;
    int dimlw = 4;
    Color fgcol=Color.black;;
    Color bgcol=Color.white;

    cgio cg = null;
    imio imdat =null;

    /**
        * This is the main component of the TreeHouse Draw application.  This is essentially the canvas in which all
     * drawing, painting, erasing, etc. occurs.
     */
    public PaintCanvas(int _x, int _y, int _w, int _h, Applet _app)
    {
        super("Paint Canvas", _x, _y, _w, _h);

        curbsh = sbsh = new squarebrush(1);

        rbsh = new roundbrush(dimbrush);

        app = _app;
        im = app.createImage(cw,ch);
        gi = im.getGraphics();

        imtmp = app.createImage(cw,ch);
        git = imtmp.getGraphics();

        imundo = app.createImage(cw,ch);
        giu = imundo.getGraphics();

        newbuffer();

        // build brushes
        MediaTracker mt = new MediaTracker(app);
        Image im;

        im = app.getImage(app.getCodeBase(),"brushes/16.gif");
        mt.addImage(im,1);
        try {
            mt.waitForAll();
        } catch (Exception e)
        {}
        ibsh[0] = new imbrush(16,im,app);

    }

    /** --------------------------------
     * OBSERVERS
     *  -------------------------------- **/
    
    public Graphics getGraphics() {
        return gi;
    }

    public Image getImage() {
        return im;
    }

    public Color getFGColor() {
        return fgcol;
    }

    public Color getBGColor() {
        return bgcol;
    }

    public Applet getApp() {
        return app;
    }

    /** --------------------------------
    * Modifiers
    *  -------------------------------- **/

    public void clearbuffer()
    {
        cacheundo();
        gi.setColor(Color.white);
        gi.fillRect(0,0,cw,ch);
        gi.setColor(Color.black);
    }

    public void newbuffer()
    {
        gi.setColor(Color.white);
        gi.fillRect(0,0,cw,ch);
        gi.setColor(Color.black);

        giu.setColor(Color.white);
        giu.fillRect(0,0,cw,ch);
        giu.setColor(Color.black);
    }

    public void push()
    {
        if (pushedp) {
            err("can't push more than once");
            return;
        }

        // swap buffers
        imstk = im; gstk = gi;

        git.drawImage(im,0,0,app);
        im = imtmp; gi = git;
        pushedp = true;
    }
    
    public void pop()
    {
        if (!pushedp) return;
        // restore buffers
        im = imstk; gi = gstk;
        gi.drawImage(imtmp,0,0,app);
        pushedp = false;
    }

    public void recover() {
        gi.drawImage(imstk,0,0,app);
    }

    public void cacheundo() {
        giu.drawImage(im,0,0,app);
    }

    public void doundo()
    {
        System.out.println("doing undo");
        git.drawImage(im,0,0,app);
        gi.drawImage(imundo,0,0,app);
        giu.drawImage(imtmp,0,0,app); // swap images effectively
    }

    public void setlw(int lw)
    {
        curbsh.setsize(lw);
    }

    /**
     * The following two methods handle the saving and opening of files within the DB
     */

    public void dosave(Graphics g, Applet app)
    {
        String filename;

        // This rasterizes the drawn image into a byte array
        // that is saved into the db as binary information
        if (imdat==null)
            imdat = new imio(cw,ch);
        byte[] b = imdat.rasterizeim(im);

        filename="BLANK FOR NOW";

            if (cg==null) cg = new cgio(app);
            
        cg.dosend(b,b.length,filename);
    }

    public void doopen(Graphics g, Applet app)
    {

        // This does nothing right now
    }

    /**
        * This method (called from the menu) allows the user to resize the canvas by dragging
     * any corner to the limits of the applet.
     */
    public void doresize(Graphics g, Applet app) {
        System.out.println("Should allow the painting region to be resized");
    }

    public void draw(Graphics g)
    {
        int i;
        Rectangle r = g.getClipBounds();
        g.setClip(cx,cy,cw,ch);
        g.drawImage(im,cx,cy,cw,ch,app);
        g.setClip(r.x,r.y,r.width,r.height);
        
        // outline the canvas
        g.setColor(Color.black);
        g.drawRect(-1+cx,-1+cy,cw+2,ch+2);
    }

    /**
     * This method checks to see if the user double clicked on the canvas
     */
    long t, lastt;
    int clickmx, clickmy;
    
    public boolean checkDoubleClick(int x, int y) {
        t = System.currentTimeMillis();
        long res = t-lastt;
        lastt = t;

        boolean isInSameSpot = ((Math.abs(clickmx - x) < 5) && (Math.abs(clickmy - y) < 5));
        clickmx = x;
        clickmy = y;
        
        return ((res<500) && (isInSameSpot));
    }

}
