//
//  Shapes.java
//  Treehousestudio
//
//  Created by Maxwell Planck on Thu Jan 23 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

import java.awt.*;
import ColorPalette;
import paintbrush;

/**
* This is a helpful drawing class that provides functionality for drawing shapes, including a rectangle,
 * a circle, and a rounded edge rectangle.
 */

public class Shapes {


    public static void rectadjusted(PaintCanvas pc, paintbrush curbsh, int x1, int y1, int x2, int y2) {
        int x,y;
        if (x1>x2) { x = x2; x2 = x1; x1 = x; }
        if (y1>y2) { y = y2; y2 = y1; y1 = y; }
        Graphics g = pc.getGraphics();
        g.setColor(pc.getFGColor());
        Simple.line(g, curbsh,x1,y1,x2,y1);
        Simple.line(g, curbsh,x1,y2,x2,y2);
        Simple.line(g, curbsh,x1,y1,x1,y2);
        Simple.line(g, curbsh,x2,y1,x2,y2);
    }

    public static void rectfilladjusted(PaintCanvas pc, paintbrush curbsh, int x1, int y1, int x2, int y2)
    {
        int x,y;
        if (x1>x2) { x = x2; x2 = x1; x1 = x; }
        if (y1>y2) { y = y2; y2 = y1; y1 = y; }

        Graphics g = pc.getGraphics();
        g.setColor(pc.getBGColor());
        g.fillRect(x1,y1,x2-x1,y2-y1);
        g.setColor(pc.getFGColor());
        rectadjusted(pc,curbsh,x1,y1,x2,y2);
    }

    public static void ovaladjusted(PaintCanvas pc, paintbrush curbsh, int x1, int y1, int x2, int y2)
    {
        int x,y;
        int w,h;
        if (x1>x2) { x = x2; x2 = x1; x1 = x; }
        if (y1>y2) { y = y2; y2 = y1; y1 = y; }

        w = (x2-x1)/2;h=(y2-y1)/2;
        Graphics g = pc.getGraphics();
        g.setColor(pc.getFGColor());
        ellipse(g,curbsh,x1+w,y1+h,w,h);
    }

    public static void ovalfilladjusted(PaintCanvas pc, paintbrush curbsh, int x1, int y1, int x2, int y2)
    {
        int x,y;
        int w,h;
        if (x1>x2) { x = x2; x2 = x1; x1 = x; }
        if (y1>y2) { y = y2; y2 = y1; y1 = y; }

        w = (x2-x1)/2;
        h = (y2-y1)/2;

        x1 = x1+w;
        y1 = y1+h;
        Graphics g = pc.getGraphics();
        g.setColor(pc.getBGColor());
        fillellipse(g,curbsh,x1+w,y1+h,w,h);
        g.setColor(pc.getFGColor());
        ellipse(g,curbsh,x1+w,y1+h,w,h);
    }

    public static void Fill4EllipsePoints(Graphics g, int CX, int CY, int x, int y)
    {

        g.drawLine(CX+x,CY+y,CX+x,CY-y);
        g.drawLine(CX-x,CY+y,CX-x,CY-y);
        g.drawLine(CX-x,CY+y,CX+x,CY+y);
        g.drawLine(CX-x,CY-y,CX+x,CY-y);
    }

    public static void fillellipse(Graphics g, paintbrush curbsh, int CX, int CY, int XRadius, int YRadius)
    {
        int X, Y,XChange, YChange,EllipseError,TwoASquare, TwoBSquare,StoppingX, StoppingY;

        if (XRadius==0&&XRadius==YRadius) {
            Simple.line(g, curbsh,CX,CY,CX,CY); return;
        }

        if (XRadius==0) {
            Simple.line(g, curbsh,CX,CY-YRadius,CX,CY+YRadius); return;
        }
        if (YRadius==0) {
            Simple.line(g, curbsh,CX-XRadius,CY,CX+XRadius,CY); return;
        }

        TwoASquare = 2*XRadius*XRadius;
        TwoBSquare = 2*YRadius*YRadius;
        X = XRadius;
        Y = 0;
        XChange = YRadius*YRadius*(1-2*XRadius);
        YChange = XRadius*XRadius;
        EllipseError = 0;
        StoppingX = TwoBSquare*XRadius;
        StoppingY = 0;
        while ( StoppingX >= StoppingY ) {
            Fill4EllipsePoints(g,CX,CY,X,Y);
            Y++;
            StoppingY+= TwoASquare;
            EllipseError+=YChange;
            YChange+=TwoASquare;
            if ((2*EllipseError + XChange) > 0 ){
                X--;
                StoppingX-= TwoBSquare;
                EllipseError+=XChange;
                XChange+=TwoBSquare;
            }
        }

        X = 0;
        Y = YRadius;
        XChange = YRadius*YRadius;
        YChange = XRadius*XRadius*(1- 2*YRadius);
        EllipseError = 0;
        StoppingX = 0;
        StoppingY = TwoASquare*YRadius;
        while ( StoppingX <=StoppingY ) {
            Fill4EllipsePoints(g,CX,CY,X,Y);
            X++;
            StoppingX+= TwoBSquare;
            EllipseError+=XChange;
            XChange+=TwoBSquare;
            if ((2*EllipseError + YChange) > 0 ) {
                Y--;
                StoppingY-= TwoASquare;
                EllipseError+=YChange;
                YChange+=TwoASquare;
            }
        }
    }

    public static void Plot4EllipsePoints(Graphics g, paintbrush curbsh, int CX, int CY, int x, int y)
    {
        curbsh.paint(g,CX+x,CY+y);
        curbsh.paint(g,CX-x,CY+y);
        curbsh.paint(g,CX-x,CY-y);
        curbsh.paint(g,CX+x,CY-y);
    }

    public static void ellipse(Graphics g, paintbrush curbsh, int CX, int CY, int XRadius, int YRadius)
    {
        int X, Y,XChange, YChange,EllipseError,TwoASquare, TwoBSquare,StoppingX, StoppingY;

        if (XRadius==0&&XRadius==YRadius) {
            Simple.line(g, curbsh,CX,CY,CX,CY); return;
        }

        if (XRadius==0) {
            Simple.line(g, curbsh,CX,CY-YRadius,CX,CY+YRadius); return;
        }
        if (YRadius==0) {
            Simple.line(g, curbsh,CX-XRadius,CY,CX+XRadius,CY); return;
        }

        TwoASquare = 2*XRadius*XRadius;
        TwoBSquare = 2*YRadius*YRadius;
        X = XRadius;
        Y = 0;
        XChange = YRadius*YRadius*(1-2*XRadius);
        YChange = XRadius*XRadius;
        EllipseError = 0;
        StoppingX = TwoBSquare*XRadius;
        StoppingY = 0;
        while ( StoppingX >= StoppingY ) {
            Plot4EllipsePoints(g,curbsh,CX,CY,X,Y);
            Y++;
            StoppingY+= TwoASquare;
            EllipseError+=YChange;
            YChange+=TwoASquare;
            if ((2*EllipseError + XChange) > 0 ){
                X--;
                StoppingX-= TwoBSquare;
                EllipseError+=XChange;
                XChange+=TwoBSquare;
            }
        }

        X = 0;
        Y = YRadius;
        XChange = YRadius*YRadius;
        YChange = XRadius*XRadius*(1- 2*YRadius);
        EllipseError = 0;
        StoppingX = 0;
        StoppingY = TwoASquare*YRadius;
        while ( StoppingX <=StoppingY ) {
            Plot4EllipsePoints(g,curbsh,CX,CY,X,Y);
            X++;
            StoppingX+= TwoBSquare;
            EllipseError+=XChange;
            XChange+=TwoBSquare;
            if ((2*EllipseError + YChange) > 0 ) {
                Y--;
                StoppingY-= TwoASquare;
                EllipseError+=YChange;
                YChange+=TwoASquare;
            }
        }
    }    

}
