//
//  THSMenuBar.java
//  Treehousestudio
//
//  Created by Maxwell Planck on Fri Jan 31 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

import java.awt.*;

/**
 * This holds all menus... it is the menubar
 */
public class THSMenuBar extends THSPanel {

    private int fsize = 12;
    private int width, height;
    private int menuPos;
    private int space = 8; // spacing between each THSMenu

    private Font menufont;
    private FontMetrics fm;
    /**
     * This instantiates the menu that is to be drawn in the specified Graphics object
     */
    public THSMenuBar(Graphics gi, int cbw, int mbarh) {
        super("Menu Bar", 0, 0, cbw, mbarh);
        width = cbw;
        height = mbarh;
        
        menufont = new Font("Helvetica", Font.BOLD, fsize);
        fm = gi.getFontMetrics(menufont);
        menuPos = space;
    }

    /**
     * This draws the menus when the main application recognizes mouse activity
     */
    public void draw(Graphics gi)
    {
        ((Graphics2D) gi).setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);

        gi.setFont(menufont);
        
        gi.setColor(Color.white);
        gi.fillRect(0,0,width,height);
        gi.setColor(Color.black);
        gi.drawLine(0,height,width,height);

        for (int i = 0; i < children.size(); i++) {
            ((THSMenu) children.get(i)).draw(gi);
        }

    }

    /**
     * This method adds the THSMenu to this menubar by first creating an instance of a THSMenu and then
     * placing it properly with all the other Menus.  This method also returns the THSMenu instantiated.
     **/
    public THSMenu addMenu(String s) {
        int xw = 0;
        THSMenu result = new THSMenu(s, menuPos, 0, xw = (fm.stringWidth(s)+space*2), height);
        menuPos += xw;

        this.addChild(result);
        return result;
    }

    public THSGeneralMenuItem currMitem;
    public THSMenu currMenu;
    
    /**
     * This displays the menuitems when the main application recognizes mouse activity on the
     * particular menu specified in the arguments.
     */
    private void dropMenu(int mx, int my) {
        // find relevant menu
        for (int i = 0; i < children.size(); i++) {
            THSMenu menu = (THSMenu) children.get(i);
            if (menu.insidep(mx, my)) {
                currMenu = (THSMenu) children.get(i);
            } else {
                menu.reset();
            }
        }
    }
    
    public void mouseDown(Event ev, int x, int y) {
        dropMenu(x, y);
        if (currMenu != null) {
            currMenu.mouseDown(ev, x, y);
        }
    }

    public void mouseDrag(Event ev, int x, int y) {
        dropMenu(x, y);
        if (currMenu != null) {
            currMenu.mouseDrag(ev, x, y);
        }
    }
    
    public void mouseUp(Event ev, int x, int y) {
        if (currMenu != null) {
            currMenu.mouseUp(ev, x, y);
        }
        currMenu = null;
    }

    public void message(String fromWho, Object odat) {}
    public boolean keyDown(Event ev, int k) { return false; }
}
